<?php
/*
   TM Offline Stats v1.1
   Copyright (c) 2006-2009 Alexander Domnin

   This program is licenced under the
   Creative Commons Attribution-Noncommercial-No Derivative Works 3.0 Unported.
   To view a copy of this licence, visit http://creativecommons.org/licenses/by-nc-nd/3.0/

   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
   without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

error_reporting(E_ALL);
ini_set("display_errors", 1); 

function id_get($str) {
   return substr(md5($str), 0, 11);
}

function envir_toid($envir) {
   switch (strtolower($envir)) {
      case 'overall': $result = '*'; break;
      case 'stadium': $result = 'a'; break;
      case 'island' : $result = 'b'; break;
      case 'bay'    : $result = 'c'; break;
      case 'coast'  : $result = 'd'; break;
      case 'alpine' : $result = 'e'; break;
      case 'rally'  : $result = 'f'; break;
      case 'speed'  : $result = 'g'; break;
      default : $result = '!'; break;
   }
   return $result;
}

function name_clear($name) {
   $buf = preg_replace('/(\$\$)/u', "\x01", $name);
   $buf = preg_replace('/\$[iswnmgto]|\$([0-9a-f]..)/iu', '', $buf);
   $buf = preg_split('/(\$[hlpz])/iu', $buf, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
   $result = '';
   $link = false;
   foreach($buf as $tok) {
      if ($tok == '$h' || $tok == '$H' ||
          $tok == '$l' || $tok == '$L' ||
          $tok == '$p' || $tok == '$P')
         $link ? $link = false : $link = true;
      else if ($tok == '$z' || $tok == '$Z')
         $link = false;
      else if ($link) {
         $hlbp = strpos($tok, '[');
         $hlep = strrpos($tok, ']');
         if ($hlbp !== false && $hlep !== false)
            $result .= substr($tok, 0, $hlbp).substr($tok, $hlep+1);
         else if ($hlbp !== false && $hlep === false)
            $result .= substr($tok, 0, $hlbp);
         else if ($hlbp === false && $hlep !== false)
            $result .= substr($tok, $hlep+1);
         else
            $result .= $tok;
      }
      else
         $result .= $tok;
   }
   return trim(preg_replace("/\x01/u", '$', $result));
}

function ts_format($ts) {
   if ($ts == '-' || $ts == '...') {
      $result = $ts;
   }
   else if (is_numeric($ts)) {
      $result = @date("j-m-Y H:i", $ts);
   }
   else {
      list($year, $month, $day, $hour, $minute, $second) =
         sscanf($ts, "%4s/%2s/%2s %2s:%2s:%s");
      $result = @date("j-m-Y H:i", @mktime($hour, $minute, $second, $month, $day, $year));
   }
   return $result;
}

function float_format($float) {
   return sprintf("%.2f", $float);
}

?>